#ifndef ELDBUS_MODEL_ARGUMENTS_EO_HH
#define ELDBUS_MODEL_ARGUMENTS_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "eldbus_model_arguments.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
#include "eo_base.eo.hh"
namespace eldbus { namespace model { 
struct Arguments;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eldbus::model::Arguments> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eldbus { namespace model { 
struct Arguments {
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_ARGUMENTS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eldbus::model::Arguments() const;
   operator ::eldbus::model::Arguments&();
   operator ::eldbus::model::Arguments const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Arguments,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Arguments const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace eldbus { namespace model { 
struct Arguments : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Model)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Arguments( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Arguments(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Arguments(Arguments const& other) = default;
   Arguments(Arguments&& other) = default;
   Arguments& operator=(Arguments const& other) = default;
   Arguments& operator=(Arguments&& other) = default;
   Arguments()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Arguments( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Arguments(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_ARGUMENTS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Arguments,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Arguments const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Arguments) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Arguments>::value, "");
} } 
#include "eldbus_model_arguments.eo.impl.hh"
#endif
